<?php

namespace app\controller\admin;

use app\service\ConfServiceFacade;
use laytp\controller\Backend;
use think\facade\Db;

include(IA_ROOT_WK . '/extend/auth/AuthInfo.php');
include(IA_ROOT_WK . '/extend/auth/Authorization.php');

class Console extends Backend
{
    protected $noNeedAuth = [];
    protected $noNeedLogin = [];

    /**
     * 获取登录后台是否需要验证码的配置
     * 这个接口是后台登录界面使用的，给这个接口独立的访问权限，无需登录，无需鉴权
     */
    public function index()
    {
        global $_W;
        $Authorization  = new \Authorization();
        if(SYS_TYPE == 'W7'){
            if(W7_TYPE =='W7C'){
                session_start();
                $Authorization::main();
            }
        }else{
            session_start();
            $Authorization::main();
        }
        $data=[];

        $today = date("Y-m-d");
        $yesterday = date("Y-m-d",strtotime("-1 day"));
        $yesterdayWhere = [ ['uniacid','=',$_W['uniacid']],['create_time','>',$yesterday ],['create_time','<',$today ] ];

        $data['user_num'] = \app\model\User::where('uniacid','=',$_W['uniacid'])->count();
        $data['user_num_yesterday'] = \app\model\User::where($yesterdayWhere)->count();
        $data['paid_sum'] = \app\model\Order::where(['paid' =>1,'uniacid'=>$_W['uniacid']])->sum('pay_price');
        $data['paid_sum_yesterday'] = \app\model\Order::where([['paid' ,'=',1],['uniacid','=',$_W['uniacid']],['create_time','>',$yesterday ],['create_time','<',$today ] ])->sum('pay_price');
        $data['cashout_sum'] = \app\model\commission\Cashout::where(['status' =>1,'uniacid'=>$_W['uniacid']])->sum('extract_price');
        $data['cashout_sum_yesterday'] = \app\model\commission\Cashout::where($yesterdayWhere)->sum('extract_price');
        $data['question_num'] = \app\model\Question::where('uniacid','=',$_W['uniacid'])->count();
        $data['question_num_yesterday'] = \app\model\Question::where($yesterdayWhere)->count();
        $data['commission_user_num'] = \app\model\commission\User::where('uniacid','=',$_W['uniacid'])->count();
        $data['commission_user_num_yesterday'] = \app\model\commission\User::where($yesterdayWhere)->count();
        $data['active_num_today'] = \app\model\Question::where([['uniacid','=',$_W['uniacid']],['create_time','>',$today]])->group('uid')->count();
        $data['active_num_yesterday'] = \app\model\Question::where($yesterdayWhere)->group('uid')->count();
        $moduleInfo = $Authorization::getModuleInfo();
        if($moduleInfo){
            $data['mudule_info'] = $moduleInfo;
        }
        $data['php_version'] = PHP_VERSION;
        $data['questionList'] = \app\model\Question::where('uniacid','=',$_W['uniacid'])->order('id desc')->limit(10)->select();
        $data['billList'] = \app\model\Bill::where('uniacid','=',$_W['uniacid'])->order('id desc')->limit(50)->with('userinfo')->select();
        $data['orderList'] = \app\model\Order::where(['uniacid'=>$_W['uniacid'],'paid'=>1])->order('id desc')->limit(10)->with(['memberInfo','userInfo'])->select();
        return $this->success('获取成功', $data);
    }

    public function check(){
        $Authorization  = new \Authorization();
        $res = $Authorization::updateMain('check');
        if(!$res){
            return $this->error('数据获取失败');
        }
        $moduleInfo = $Authorization::getModuleInfo();
        if($moduleInfo){
            $res['mudule_info'] = $moduleInfo;
        }
        return $this->success('获取成功', $res);
    }

    public function updateVersion()
    {
        $Authorization  = new \Authorization();
        $res = $Authorization::updateMain('update');
        // if(!$res){
        //     return $this->error('数据获取失败');
        // }
        return $this->success('获取成功', $res);
    }
}
