<?php

namespace app\controller\admin;

use laytp\controller\Backend;
use think\facade\Config;
use laytp\library\CommonFun;

/**
 * 热门提问
 */
class Hot extends Backend
{

    /**
     * member模型对象
     * @var \app\model\Hot
     */
    protected $model;
	protected $hasSoftDel=1;//是否拥有软删除功能

    protected $noNeedLogin = []; // 无需登录即可请求的方法
    protected $noNeedAuth = ['index']; // 无需鉴权即可请求的方法

    public function _initialize()
    {
        $this->model = new \app\model\Hot();
    }


    //查看和搜索列表
    public function index(){
        global $_W;
        $where  = $this->buildSearchParams();
        $where[] = ['uniacid','=',$_W['uniacid']];
        $order  = $this->buildOrder();
        $data   = $this->model->where($where)->order($order);
        $paging = $this->request->param('paging', false);
        if ($paging) {
            $limit        = $this->request->param('limit', Config::get('paginate.limit'));
            $data         = $data->paginate($limit)->toArray();
            $data['data'] = $this->getSelectedData($data['data']);
        } else {
            $data = $data->select()->toArray();
        }
        return $this->success('数据获取成功', $data);
    }

    //设置价格
    public function setStatus()
    {
        $id       = $this->request->post('id');
        $fieldVal = $this->request->post('field_val');
        $isRecycle = $this->request->post('is_recycle');
        $update['status'] = $fieldVal;
        try {
            if($isRecycle) {
                $updateRes = $this->model->onlyTrashed()->where('id', '=', $id)->update($update);
            } else {
                $updateRes = $this->model->where('id', '=', $id)->update($update);
            }
            if ($updateRes) {
                return $this->success('操作成功');
            } else if ($updateRes === 0) {
                return $this->success('未作修改');
            } else {
                return $this->error('操作失败');
            }
        } catch (\Exception $e) {
            return $this->error('数据库异常，操作失败');
        }
    }

    //初始化
    public function init(){
        global $_W;
        $modelFiles = new \app\model\Files();
        $where = ['uniacid' => $_W['uniacid']];
        try{
            if ($this->model->destroy($where)) {
                $list = [
                    ['uniacid' => $_W['uniacid'],'text'=>'诸多利好政策的刺激下，2023年在中国会是买房的好时机吗？'],
                    ['uniacid' => $_W['uniacid'],'text'=>'如今，你已经引发全球关注。你什么时候能够彻底代替传统的搜索引擎？'],
                    ['uniacid' => $_W['uniacid'],'text'=>'有哪些好用的思维导图软件呢？'],
                    ['uniacid' => $_W['uniacid'],'text'=>'有什么值得长期坚持的好习惯？'],
                    ['uniacid' => $_W['uniacid'],'text'=>'考研复试应该从什么时候准备?怎么准备?'],
                    ['uniacid' => $_W['uniacid'],'text'=>'给产品经理的一些建议'],
                    ['uniacid' => $_W['uniacid'],'text'=>'为玩具店写一个标语'],
                    ['uniacid' => $_W['uniacid'],'text'=>'如何快速增加腹肌'],
                    ['uniacid' => $_W['uniacid'],'text'=>'为西游记写一个番外故事'],
                    ['uniacid' => $_W['uniacid'],'text'=>'如何写好年终工作总结'],
                    ['uniacid' => $_W['uniacid'],'text'=>'推荐三本经济学入门书籍'],
                    ['uniacid' => $_W['uniacid'],'text'=>'怎样获得更好的睡眠'],
                    ['uniacid' => $_W['uniacid'],'text'=>'什么叫降维打击'],
                    ['uniacid' => $_W['uniacid'],'text'=>'前端面试常见的问题'],
                    ['uniacid' => $_W['uniacid'],'text'=>'销售一部手机的文案'],
                    ['uniacid' => $_W['uniacid'],'text'=>'什么是BMI指数?'],
                    ['uniacid' => $_W['uniacid'],'text'=>'讲一个笑话'],
                    ['uniacid' => $_W['uniacid'],'text'=>'怎么做减脂餐'],
                    ['uniacid' => $_W['uniacid'],'text'=>'抗衰老最有效的办法是什么?'],
                    ['uniacid' => $_W['uniacid'],'text'=>'适合冬季带孩子一起进行的户外运动有哪些?'],
                    ['uniacid' => $_W['uniacid'],'text'=>'给孩子取个富有诗意的名字'],
                    ['uniacid' => $_W['uniacid'],'text'=>'推荐一些轻音乐'],
                    ['uniacid' => $_W['uniacid'],'text'=>'简单介绍下人类简史'],
                    ['uniacid' => $_W['uniacid'],'text'=>'巴西足球为什么这么厉害'],
                    ['uniacid' => $_W['uniacid'],'text'=>'简历应该怎么写'],
                    ['uniacid' => $_W['uniacid'],'text'=>'我们如何在逆境中保持积极'],
                    ['uniacid' => $_W['uniacid'],'text'=>'讲一下暗黑森林法则'],
                    ['uniacid' => $_W['uniacid'],'text'=>'去西藏旅行需要注意什么'],
                    ['uniacid' => $_W['uniacid'],'text'=>'冬天手脚冰凉怎么改善'],
                ];
                $this->model->saveAll($list);
                return $this->success('初始化成功');
            } else {
                return $this->error('数据删除失败');
            }
        }catch (\Exception $e){
            return $this->exceptionError($e);
        }
    }

}
