<?php

namespace app\controller\admin;

use laytp\controller\Backend;
use think\facade\Config;
use laytp\library\CommonFun;

/**
 * 订单
 */
class Order extends Backend
{

    /**
     * order模型对象
     * @var \app\model\Order
     */
    protected $model;
	protected $hasSoftDel=0;//是否拥有软删除功能

    protected $noNeedLogin = []; // 无需登录即可请求的方法
    protected $noNeedAuth = ['index', 'info']; // 无需鉴权即可请求的方法

    public function _initialize()
    {
        $this->model = new \app\model\Order();
    }


    //查看和搜索列表
    public function index(){
        global $_W;
        $where  = $this->buildSearchParams();
        $where[] = ['uniacid','=',$_W['uniacid']];
        $order  = $this->buildOrder();
        $data   = $this->model->where($where)->order($order)->with(['memberInfo','userInfo']);
        $paging = $this->request->param('paging', false);
        if ($paging) {
            $limit        = $this->request->param('limit', Config::get('paginate.limit'));
            $data         = $data->paginate($limit)->toArray();
            $data['data'] = $this->getSelectedData($data['data']);
        } else {
            $data = $data->select()->toArray();
        }
        return $this->success('数据获取成功', $data);
    }




    //查看详情
    public function info()
    {
        $id   = $this->request->param('id');
        $info = $this->model->find($id);
        return $this->success('获取成功', $info);
    }






}
