<?php

namespace app\controller\admin;

use laytp\controller\Backend;
use think\facade\Config;
use laytp\library\CommonFun;
use laytp\library\Tree;

/**
 * 示例文本
 */
class Template extends Backend
{

    /**
     * member模型对象
     * @var \app\model\Template
     */
    protected $model;
	protected $hasSoftDel=1;//是否拥有软删除功能

    protected $noNeedLogin = []; // 无需登录即可请求的方法
    protected $noNeedAuth = ['index']; // 无需鉴权即可请求的方法

    public function _initialize()
    {
        $this->model = new \app\model\Template();
    }


    //查看和搜索列表
    public function index(){
        global $_W;
        $where  = $this->buildSearchParams();
        $where[] = ['uniacid','=',$_W['uniacid']];
        $order  = $this->buildOrder();
        $order = ['sort'=>'desc','id' => 'desc'];
        $sourceData   = $this->model->where($where)->order($order);
        $isTree = $this->request->param('is_tree');
        if($isTree){
            $menuTreeObj = Tree::instance();
            $menuTreeObj->init($sourceData->select()->toArray());
            $data = $menuTreeObj->getRootTrees();
        }else{
            $paging = $this->request->param('paging', false);
            if ($paging) {
                $limit        = $this->request->param('limit', Config::get('paginate.limit'));
                $data         = $$sourceData->paginate($limit)->toArray();
                $data['data'] = $this->getSelectedData($data['data']);
            } else {
                $data = $$sourceData->select()->toArray();
            }
        }
        return $this->success('数据获取成功', $data);
    }

    //删除
    public function del()
    {
        $ids = $this->request->post('ids');
        if (!$ids) {
            return $this->error('参数ids不能为空');
        }

        $sourceData = $this->model->select()->toArray();
        $treeLib = Tree::instance();
        $treeLib->init($sourceData);
        $childIds = $treeLib->getChildIds($ids);

        if ($this->model->destroy($childIds)) {
            return $this->success('数据删除成功');
        } else {
            return $this->error('数据删除失败');
        }
    }

    //初始化
    public function init(){
        global $_W;
        $where = ['uniacid' => $_W['uniacid']];
        try{
            if ($this->model->destroy($where)) {
                $fileId0 =$this->model->insertGetId([
                       'pid' => 0,
                       'title' => '效率工具',
                       'uniacid' =>$_W['uniacid'],
                       'create_time' => date('Y-m-d H:i:s'),
                       'update_time' => date('Y-m-d H:i:s')
                   ]);
                $list0 = [
                    ['uniacid' => $_W['uniacid'],'guide'=>'写一份报告','title'=>'周报年报生成器','sub_title'=>'输入工作内容，帮你快速完成周报月报年报。','pid'=>$fileId0,'code'=>'weekly'],
                    ['uniacid' => $_W['uniacid'],'guide'=>'用客套话生成一封邮件','title'=>'邮件小助手','sub_title'=>'描述场景和需求，帮你生成客套话。','pid'=>$fileId0],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是阅读小助手,帮用户解释下这段文字','title'=>'阅读小助手','sub_title'=>'输入不懂的文字段落并让小助手解释。','pid'=>$fileId0],
                    ['uniacid' => $_W['uniacid'],'guide'=>'用SWOT分析法,生成一份SWOT分析报告','title'=>'SWOT分析法','sub_title'=>'请详细描述目前事件的情势，小助手会帮你生成一份SWOT分析报告。','pid'=>$fileId0],
                    ['uniacid' => $_W['uniacid'],'guide'=>'帮用户生成完整的OKR规划','title'=>'OKR生成器','sub_title'=>'请输入你要完成的目标，小助手为你生成完整的OKR规划','pid'=>$fileId0],
                    ['uniacid' => $_W['uniacid'],'guide'=>'学术论文生成,帮助用户进行研究、分析、组织思路并编写出符合学术标准的论文。','title'=>'学术论文','sub_title'=>'写各种类型的学术论文，包括科技论文、文学论文、社科论文等。它可以帮助你进行研究、分析、组织思路并编写出符合学术标准的论文。','pid'=>$fileId0]
                ];
                $this->model->saveAll($list0);
                $fileId1 =$this->model->insertGetId([
                       'pid' => 0,
                       'title' => '生活',
                       'uniacid' =>$_W['uniacid'],
                       'create_time' => date('Y-m-d H:i:s'),
                       'update_time' => date('Y-m-d H:i:s')
                   ]);
                $list1 = [
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是餐厅点评小助手,请帮用户点评下','title'=>'餐厅点评小助手','sub_title'=>'输入关键词，小助手帮你生成餐厅点评','pid'=>$fileId1],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是商品点评小助手,请帮用户点评下','title'=>'商品点评小助手','sub_title'=>'输入商品名和相关信息，小助手帮你生成商品评价','pid'=>$fileId1],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是塔罗牌预测小助手','title'=>'塔罗牌预测小助手','sub_title'=>'输入想预测的占卜内容，帮你预测运势','pid'=>$fileId1],
                    ['uniacid' => $_W['uniacid'],'guide'=>'请帮用户生成小红书风格的文章','title'=>'小红书风格模拟器','sub_title'=>'输入你想发布的内容，帮你生成小红书的风格。','pid'=>$fileId1,'code'=>'xiaohongshu'],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是解梦小助手','title'=>'解梦小助手','sub_title'=>'请描述你的梦境，小助手将为你作出简单解析。','pid'=>$fileId1],
                    ['uniacid' => $_W['uniacid'],'guide'=>'帮用户写一封节日祝福','title'=>'节日祝福','sub_title'=>'输入节日名称和关键词，帮你写一封节日祝福','pid'=>$fileId1],
                    ['uniacid' => $_W['uniacid'],'guide'=>'帮用户解决职场问题','title'=>'职场开解小树洞','sub_title'=>'请输入遇到的职场问题，让小树洞为你排忧解难。','pid'=>$fileId1],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是知识小百科,帮用户科普百科知识','title'=>'知识小百科','sub_title'=>'请输入不懂的问题或概念，小助手为你科普','pid'=>$fileId1],
                ];
                $this->model->saveAll($list1);
                $fileId2 =$this->model->insertGetId([
                       'pid' => 0,
                       'title' => '娱乐',
                       'uniacid' =>$_W['uniacid'],
                       'create_time' => date('Y-m-d H:i:s'),
                       'update_time' => date('Y-m-d H:i:s')
                   ]);
                $list2 = [
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是夸夸小助手','title'=>'夸夸小助手','sub_title'=>'请描述你想夸的人和想夸的点，小助手帮你夸夸','pid'=>$fileId2],
                    ['uniacid' => $_W['uniacid'],'guide'=>'生成知乎风格的文章','title'=>'知乎风格问答器','sub_title'=>'生成知乎风格的文章','pid'=>$fileId2],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是emoji翻译小助手','title'=>'emoji翻译小助手','sub_title'=>'请输入一段文字，小助手为你翻译成Emoji','pid'=>$fileId2],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是甩锅小助手,为用户生成一段甩锅的话','title'=>'甩锅小助手','sub_title'=>'请输入想要甩锅的事件，小助手会为你生成一段甩锅的话。','pid'=>$fileId2],
                    ['uniacid' => $_W['uniacid'],'guide'=>'哄女友小助手,生成一段道歉的话','title'=>'哄女友小助手','sub_title'=>'请输入女朋友生气的原因，小助手为你生成一段道歉的话。','pid'=>$fileId2],
                    ['uniacid' => $_W['uniacid'],'guide'=>'恋爱话术小助手,教用户土味情话','title'=>'恋爱话术小助手','sub_title'=>'让小助手教你土味情话','pid'=>$fileId2],
                ];
                $this->model->saveAll($list2);
                $fileId3 =$this->model->insertGetId([
                       'pid' => 0,
                       'title' => '功能',
                       'uniacid' =>$_W['uniacid'],
                       'create_time' => date('Y-m-d H:i:s'),
                       'update_time' => date('Y-m-d H:i:s')
                   ]);
                $list3 = [
                    ['uniacid' => $_W['uniacid'],'guide'=>'解释名词','title'=>'名词解释','sub_title'=>'查询并解释任何只是概念','pid'=>$fileId3],
                    ['uniacid' => $_W['uniacid'],'guide'=>'制定学习计划','title'=>'制定学习计划','sub_title'=>'制定各种学习计划','pid'=>$fileId3],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是答题助手','title'=>'答题助手','sub_title'=>'回答各种领域的作业难题','pid'=>$fileId3],
                    ['uniacid' => $_W['uniacid'],'guide'=>'推荐几首用户可能喜欢的歌','title'=>'歌曲推荐','sub_title'=>'推荐几首你可能喜欢的歌','pid'=>$fileId3],
                ];
                $this->model->saveAll($list3);
                $fileId4 =$this->model->insertGetId([
                       'pid' => 0,
                       'title' => '创作型助手',
                       'uniacid' =>$_W['uniacid'],
                       'create_time' => date('Y-m-d H:i:s'),
                       'update_time' => date('Y-m-d H:i:s')
                   ]);
                $list4 = [
                    ['uniacid' => $_W['uniacid'],'guide'=>'评论电影、书籍或音乐','title'=>'电影评论','sub_title'=>'评论电影、书籍或音乐','pid'=>$fileId4],
                    ['uniacid' => $_W['uniacid'],'guide'=>'生成一条文艺朋友圈','title'=>'朋友圈文案','sub_title'=>'生成一条文艺朋友圈','pid'=>$fileId4],
                    ['uniacid' => $_W['uniacid'],'guide'=>'讲一个睡前故事','title'=>'睡前故事','sub_title'=>'讲一个睡前故事','pid'=>$fileId4],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是文案专家','title'=>'写文案','sub_title'=>'为任何产品撰写介绍文案','pid'=>$fileId4],
                    ['uniacid' => $_W['uniacid'],'guide'=>'写份工作报告','title'=>'写报告','sub_title'=>'定制生成各领域的报告','pid'=>$fileId4,'code'=>'baogao'],
                    ['uniacid' => $_W['uniacid'],'guide'=>'你是一名专业的翻译助手','title'=>'翻译','sub_title'=>'对各种语言进行翻译','pid'=>$fileId4,'code'=>'fanyi'],
                ];
                $this->model->saveAll($list4);
                return $this->success('初始化成功');
            } else {
                return $this->error('数据删除失败');
            }
        }catch (\Exception $e){
            return $this->exceptionError($e);
        }
        // return $this->success('获取成功', $_W);
    }

    //设置积分
    public function setStatus()
    {
        $id       = $this->request->post('id');
        $fieldVal = $this->request->post('field_val');
        $isRecycle = $this->request->post('is_recycle');
        $update['status'] = $fieldVal;
        try {
            if($isRecycle) {
                $updateRes = $this->model->onlyTrashed()->where('id', '=', $id)->update($update);
            } else {
                $updateRes = $this->model->where('id', '=', $id)->update($update);
            }
            if ($updateRes) {
                return $this->success('操作成功');
            } else if ($updateRes === 0) {
                return $this->success('未作修改');
            } else {
                return $this->error('操作失败');
            }
        } catch (\Exception $e) {
            return $this->error('数据库异常，操作失败');
        }
    }

    //设置排序
    public function setSort()
    {
        $id       = $this->request->post('id');
        $fieldVal = $this->request->post('field_val');
        $isRecycle = $this->request->post('is_recycle');
        $update['sort'] = $fieldVal;
        try {
            if($isRecycle) {
                $updateRes = $this->model->onlyTrashed()->where('id', '=', $id)->update($update);
            } else {
                $updateRes = $this->model->where('id', '=', $id)->update($update);
            }
            if ($updateRes) {
                return $this->success('操作成功');
            } else if ($updateRes === 0) {
                return $this->success('未作修改');
            } else {
                return $this->error('操作失败');
            }
        } catch (\Exception $e) {
            return $this->error('数据库异常，操作失败');
        }
    }

}
