<?php

namespace app\controller\admin\system;

use app\service\ConfServiceFacade;
use laytp\controller\Backend;
use laytp\library\CommonFun;

use \app\model\admin\Menu;

/**
 * 小程序上传
 */
class UploadMiniapp extends Backend
{

	  protected $hasSoftDel=0;//是否拥有软删除功能

    protected $noNeedLogin = []; // 无需登录即可请求的方法
    protected $noNeedAuth = []; // 无需鉴权即可请求的方法

	//查看详情
    public function version()
    {
      $apihost = base64_decode(API_HOST);
      $apipath = '/auth/finfo/module_version?module_name=';
      $version = @file_get_contents($apihost.$apipath.MODULE_NAME);
      return $this->success('获取成功', $version);
    }

    //检查是否有上传菜单
    public function checkMenu()
    {
      $menu = \app\model\admin\Menu::find(98);
	  if(!$menu){
		  return $this->error('无数据',2);
	  }
      return $this->success('获取成功',$menu);
    }

	//添加上传菜单,id必须98
    public function addMenu()
    {
	  $menu = Menu::create([
  		  'id'       => 98,
  		  'name'           => '上传小程序',
  		  'href'           => '/admin/conf/miniapp/upload.html',
  		  'open_type'   => '_iframe',
  		  'rule' => '',
  		  'is_menu'       => 1,
		  'sort'       => 0,
		  'pid'       => 95,
		  'is_show'       => 1,
		  'icon'       => '',
		  'des'       => NULL,
  		  'create_time'    => date('Y-m-d H:i:s'),
		  'update_time'    => date('Y-m-d H:i:s'),
  	  ]);
	  if(!$menu){
		  return $this->error('无数据');
	  }
      return $this->success('获取成功',$menu);
    }

    // 工具二维码
    public function loginimg()
    {
		global $_W;
        $param = $this->request->param();
        $version =$param['version']?$param['version']:'1.0.0';
        $intro =$param['intro']?$param['intro']:'全新版本HoldInfinityInThePalmOfYourHand';
		$site = $_SERVER['HTTP_HOST'];
        $miniapp = ConfServiceFacade::groupGet('system.miniapp', true);
        $appid = $miniapp['appid'];
        if(!$appid){
            return $this->error('请先配置小程序的APPID');
        }
         $res = $this->request('loginimg&sroot=' . urlencode($site.SURL) . '&uid=' . $_W['uniacid'] . '&v=' . $version . '&de=' . $intro . '&m=' . MODULE_NAME . '&appid=' . $appid.'&w7type='.W7_TYPE.'&isr='.IS_R);
        if(!$res){
            return $this->error('获取图片失败');
        }
        $img =  "data:image/jpeg;base64," . base64_encode($res);
        return $this->success('获取成功', $img);
    }

    // 扫码登录
    public function login()
    {
        $res = $this->request('login');
        return $this->success('获取成功', $res);
    }

    // 上传小程序
    public function upapp()
    {
		global $_W;
        $upvers = '';
        $updes = '';
		$miniapp = ConfServiceFacade::groupGet('system.miniapp', true);
        $appid = $miniapp['appid'];
		$site = $_SERVER['HTTP_HOST'];
        $return =  $this->request('upapp&sroot=' . urlencode($site.SURL) . '&m=' . MODULE_NAME . '&upversion=' . $upvers . '&updes=' . urlencode($updes) . '&appid=' . $appid . '&uniacid='.$_W['uniacid']);
        return $this->success('获取成功', $return);
    }

    // 工具上传的小程序参数
    public function upjson()
    {
        return $this->success('获取成功', $this->request('upappinfo&m=' . MODULE_NAME));
    }

    // 请求方法
    public function request($do)
    {
        $apihost = ''.base64_decode(UP_HOST);
        $site = $_SERVER['HTTP_HOST'];
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $apihost.'?s=' . $site . '&do=' . $do);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        $data = curl_exec($curl);
        curl_close($curl);
        return $data;
    }


}
