<?php
/**
 * 类别模型
 */
namespace app\model;

use laytp\BaseModel;
use think\model\concern\SoftDelete;
use laytp\library\UploadDomain;

class Gallery extends BaseModel
{
	use SoftDelete;

    //模型名
    protected $name = 'gallery';

    //附加属性
    protected $append = ['imgs_file','imgs_path'];

    //时间戳字段转换


    //关联模型
    public function modelsInfo(){
        return $this->belongsTo('app\model\Models','model_id','model_id')->bind(['model_name'=>'name']);
    }

	public function userInfo(){
        return $this->belongsTo('app\model\User','uid','id')->bind(['nickname','avatar','id_number']);
    }

    //新增属性的方法
	public function getImgsFileAttr($value, $data)
	{
		return (isset($data['imgs']) && $data['imgs']) ? UploadDomain::multi($data['imgs']) : '';
	}
	public function getImgsPathAttr($value, $data)
	{
		return (isset($data['imgs']) && $data['imgs']) ? UploadDomain::multiJoin($data['imgs']) : '';
	}

    public function getCreateTimeIntAttr($value, $data)
	{
		return isset($data['create_time']) ? strtotime($data['create_time']) : 0;
	}

    public function getUpdateTimeIntAttr($value, $data)
	{
		return isset($data['update_time']) ? strtotime($data['update_time']) : 0;
	}

	public function getDeleteTimeIntAttr($value, $data)
	{
		return isset($data['delete_time']) ? strtotime($data['delete_time']) : 0;
	}
}
