<?php
/**
 * 会员管理模型
 */
namespace app\model;

use laytp\BaseModel;
use think\model\concern\SoftDelete;

class User extends BaseModel
{
	use SoftDelete;

    //模型名
    protected $name = 'user';

    //附加属性
    protected $append = ['is_vip_time_validity','vip_time_str','login_time_int','create_time_int','update_time_int','delete_time_int','vip_time'];

    //时间戳字段转换
    // protected $type = [
	// 	'vip_time'  =>  'timestamp:Y-m-d H:i:s',
	// ];

    //表名


    //关联模型
    public function avatarPicFile(){
        return $this->belongsTo('app\model\Files','avatar_pic','id');
    }

	public function question(){
        return  $this->hasMany('app\model\Question','uid','id');
    }

	public function commission1(){
        return  $this->hasMany('app\model\commission\Team','pid','id');
    }

	public function commission2(){
        return  $this->hasMany('app\model\commission\Team','gid','id');
    }

	public function commission3(){
        return  $this->hasMany('app\model\commission\Team','gfid','id');
    }

    //新增属性的方法
	public function getIsVipTimeValidityAttr($value, $data)
	{
		$return = 0;
		if(isset($data['vip_time'])){
			$return = $data['vip_time']<time() ? 0:1;
		}
		return $return;
	}
    public function getVipTimeStrAttr($value, $data)
	{
		return isset($data['vip_time']) ? date("Y-m-d H:i:s",$data['vip_time']) : 0;
	}

	public function getLoginTimeIntAttr($value, $data)
	{
		return isset($data['login_time']) ? strtotime($data['login_time']) : 0;
	}

	public function getCreateTimeIntAttr($value, $data)
	{
		return isset($data['create_time']) ? strtotime($data['create_time']) : 0;
	}

	public function getUpdateTimeIntAttr($value, $data)
	{
		return isset($data['update_time']) ? strtotime($data['update_time']) : 0;
	}

	public function getDeleteTimeIntAttr($value, $data)
	{
		return isset($data['delete_time']) ? strtotime($data['delete_time']) : 0;
	}
}
