<?php
/**
 * 首页菜单管理模型
 */
namespace app\model\commission;

use app\model\Gallery;
use app\model\Question;
use laytp\BaseModel;
use laytp\library\UploadDomain;
use think\model\concern\SoftDelete;

class Team extends BaseModel
{
    // use SoftDelete;

    //模型名，导出功能需要读取此值，所以需要设置成public
    protected $name = 'commission_team';

    //时间戳字段转换
    protected $type = [];

    protected $append = ['create_time_int'];

    //表名


    //关联模型
    public function userinfo(){
        return $this->belongsTo('app\model\User','uid','id')->bind(['nickname','avatar','id_number'])->field(['id','nickname','avatar','id_number']);
    }

    public function pidUserinfo(){
        return $this->belongsTo('app\model\User','pid','id')->bind(['nickname','avatar','id_number'])->field(['id','nickname','avatar','id_number']);
    }
    public function questionCount(){
        return $this->hasMany(Question::class,'uid','uid');
    }
    public function galleryCount(){
        return $this->hasMany(Gallery::class,'uid','uid');
    }
    public function payMoney(){
        return $this->hasMany(\app\model\Order::class,'uid','uid')->where('paid',1)->sum('pay_price');
    }
    //新增属性的方法
    public function getCreateTimeIntAttr($value, $data)
	{
		return isset($data['create_time']) ? strtotime($data['create_time']) : 0;
	}
}
