<?php

namespace app\service;

use app\service\api\UserServiceFacade;
use app\service\api\MiniappServiceFacade;
use app\service\api\WechatServiceFacade;
use plugin\ali_sms\service\AliSmsServiceFacade;
use laytp\library\UploadDomain;
use laytp\library\Random;
use laytp\traits\Error;
use think\facade\Cache;
use think\facade\Config;

/**
 * 微信消息服务器实现者
 * Class Auth
 * @package app\service
 */
class WechatMessage
{
    use Error;

    /**
     * 统一消息发送
     * @return array
     */
    public function Unified($uid)
    {
        $userInfo = \app\model\User::find($uid);
        return $userInfo;
    }

    // 小程序_start

    // 支付成功通知
    public function pay_suc($uid,$orderNumber,$payPrice,$title,$content,$uniacid){
        global $_W,$_GPC;
        $_W['uniacid'] = $_GPC['uniacid'] = $uniacid;
        $userInfo = \app\model\User::find($uid);
        $tmpId = ConfServiceFacade::get('system.notification.pay_suc');
        $app = MiniappServiceFacade::option('kehu');
        $data = [
            'template_id' => $tmpId,
            'touser' => $userInfo['openid_miniapp'],
            'page' => 'pages/index/index',
            'data' => [
                'character_string1' => [
                    'value' => $orderNumber,//订单号码
                ],
                'amount4' => [
                    'value' => $payPrice.'元',//订单金额
                ],
                'phrase10' => [
                    'value' => '已支付',//付款结果
                ],
                'thing11' => [
                    'value' => $title,//支付说明
                ],
                'time12' => [
                    'value' => date('Y-m-d H:i:s'),//支付时间
                ]
            ],
        ];
        $res = $app->subscribe_message->send($data);
        file_put_contents(__DIR__ . '/pay_suc.json', json_encode($res));
        if($res['errcode'] != 0){
             return false;
         } else {
             return true;
         }
    }

    // 未读消息提醒
    public function unread_msg($uid,$name){
        $userInfo = \app\model\User::find($uid);
        $app = MiniappServiceFacade::option('kehu');
        $data = [
            'template_id' => $this->conf['kehu_unread_msg'],
            'touser' => $userInfo['openid_miniapp_kehu'],
            'page' => 'pages/index/index',
            'data' => [
                'thing1' => [
                    'value' => '您有新消息未读，请点击查看',
                ],
                'time2' => [
                    'value' => date('Y-m-d H:i:s'),
                ],
                'thing3' => [
                    'value' => $name,
                ]
            ],
        ];
        $res = $app->subscribe_message->send($data);
        if($res['errcode'] != 0){
             return false;
         } else {
             return true;
         }
    }

}
