<?php

/**
 * WeEngine System
 *
 * (c) We7Team 2022 <https://www.w7.cc>
 *
 * This is not a free software
 * Using it under the license terms
 * visited https://www.w7.cc for more details
 */

namespace W7\Sdk\Module\Support\Message;

use W7\Sdk\Module\Exceptions\ApiException;

class Message implements MessageInterface
{
    /** @var string string */
    protected $type = '';

    protected static $studlyCache = [];

    /**
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    public function __get($name)
    {
        if (property_exists($this, $name)) {
            return $this->$name;
        }
        return null;
    }

    protected static function studly($value)
    {
        $key = $value;

        if (isset(static::$studlyCache[$key])) {
            return static::$studlyCache[$key];
        }

        $value = ucwords(str_replace(['-', '_'], ' ', $value));

        return static::$studlyCache[$key] = str_replace(' ', '', $value);
    }

    /**
     * @return array
     * @throws ApiException
     */
    public function toXmlArray()
    {
        throw new ApiException(sprintf('Class "%s" cannot support transform to XML message.', __CLASS__));
    }

    /**
     * @return array
     * @throws ApiException
     */
    public function toArray()
    {
        throw new ApiException(sprintf('Class "%s" cannot support transform to array message.', __CLASS__));
    }
}
