layui.use(['laytp'], function () {
    const funRecycleController = {};
    //静态页面地址前缀
    window.htmlPrefix = facade.compatibleHtmlPath("/admin/plugin/ali_sms/");
    //后端接口地址前缀
    window.apiPrefix  = facade.compatibleApiRoute("/plugin/ali_sms/index/");

    //表格渲染
    funRecycleController.tableRender = function (where, page) {
        layui.table.render({
            elem: "#laytp-recycle-table"
            , id: "laytp-recycle-table"
            , url: facade.url("/plugin/ali_sms/index/recycle")
            , toolbar: "#recycle-default-toolbar"
            , defaultToolbar: [{
                title: '刷新',
                layEvent: 'recycle-refresh',
                icon: 'layui-icon-refresh',
            }, 'filter', 'print', 'exports']
            , where: where
            , method: "GET"
            , cellMinWidth: 120
            , skin: 'line'
            , loading: false
            , page: {
                curr: page
            }
            , parseData: function (res) { //res 即为原始返回的数据
                return facade.parseTableData(res, true);
            }
            , cols: [[ //表头
                {type:'checkbox',fixed:'left'}
				,{field:'id',title:'ID',align:'center',width:80,fixed:'left'}
				,{field:'template_code',title:'阿里云短信模板ID',align:'center',templet:function(d){
                        return layui.laytpl('{{=d.template_code}}').render({template_code:d.template_code});
                    }}
				,{field:'event',title:'事件名称',align:'center',templet:function(d){
                        return layui.laytpl('{{=d.event}}').render({event:d.event});
                    }}
				,{field:'params',title:'短信内容参数',align:'center',templet:function(d){
                    return layui.laytpl('{{=d.params}}').render({params:d.params});
                }}
				,{field:'mobile',title:'收信人手机号码',align:'center',templet:function(d){
                        return layui.laytpl('{{=d.mobile}}').render({mobile:d.mobile});
                    }}
				,{field:'status',title:'状态',align:'center',templet:function(d){
					return laytp.tableFormatter.status('status',d.status,{"value":["1","2","3"],"text":["未使用","已使用","已过期"],"default":0});
				}}
				,{field:'expire_time',title:'过期时间，0表示永不过期',align:'center',templet:function(d){
                        return layui.laytpl('{{=d.expire_time}}').render({expire_time:d.expire_time});
                    }}
				,{field:'create_time',title:'创建时间',align:'center'}
				,{field:'update_time',title:'更新时间',align:'center'}
				,{field:'delete_time',title:'删除时间',align:'center'}
                ,{field:'operation',title:'操作',align:'center',toolbar:'#recycle-default-bar',width:150,fixed:'right'}
            ]]
        });

        //监听数据表格顶部左侧按钮点击事件
        layui.table.on("toolbar(laytp-recycle-table)", function (obj) {
            var defaultTableToolbar = layui.context.get("defaultTableToolbar");
            if (defaultTableToolbar.indexOf(obj.event) !== -1) {
                //默认按钮点击事件
                laytp.tableToolbar(obj);
            } else {
                // //自定义按钮点击事件
                // switch(obj.event){
                // //自定义按钮点击事件
                // case "":
                //
                //     break;
                // }
            }
        });

        //监听数据表格[操作列]按钮点击事件
        layui.table.on('tool(laytp-recycle-table)', function (obj) {
            var defaultTableTool = layui.context.get("defaultTableTool");
            if (defaultTableTool.indexOf(obj.event) !== -1) {
                laytp.tableTool(obj);
            } else {
                // //自定义按钮
                // switch(obj.event){
                // //自定义按钮点击事件
                // case '':
                //
                //     break;
                // }
            }
        });
    };

    funRecycleController.tableRender();

    window.funRecycleController = funRecycleController;
});